Loading...
Searching...
No Matches
Sip_min_se

## Data Structures

struct | sip_min_se_s
| Structure for Min-SE header. More...

## Macros

#define | sip_min_se(sip)
| Access a SIP Min-SE header structure sip_min_se_t from sip_t.
#define | SIP_MIN_SE_INIT()
| Initializer for structure sip_min_se_t.
#define | SIPTAG_MIN_SE(x)
| Tag list item for pointer to a Min-SE header structure sip_min_se_t.
#define | SIPTAG_MIN_SE_REF(x)
| Tag list item for reference to a Min-SE header pointer.
#define | SIPTAG_MIN_SE_STR(s)
| Tag list item for string with Min-SE header value.
#define | SIPTAG_MIN_SE_STR_REF(x)
| Tag list item for reference to a Min-SE header string.

## Typedefs

typedef struct sip_min_se_s | sip_min_se_t
| @

## Functions

issize_t | sip_min_se_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Min-SE header.
issize_t | sip_min_se_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Min-SE header.
sip_min_se_t * | sip_min_se_init (sip_min_se_t x[1])
| Initialize a structure sip_min_se_t.
int | sip_is_min_se (sip_header_t const *header)
| Test if header object is instance of sip_min_se_t.
sip_min_se_t * | sip_min_se_dup (su_home_t *home, sip_min_se_t const *hdr))
| Duplicate a list of Min-SE header header structures sip_min_se_t.
sip_min_se_t * | sip_min_se_copy (su_home_t *home, sip_min_se_t const *hdr))
| Copy a list of Min-SE header header structures sip_min_se_t.
sip_min_se_t * | sip_min_se_make (su_home_t *home, char const *s))
| Make a Min-SE header structure sip_min_se_t.
sip_min_se_t * | sip_min_se_format (su_home_t *home, char const *fmt,...)))
| Make a Min-SE header from formatting result.

## Variables

msg_hclass_t | sip_min_se_class []
| Header class for Min-SE header.
tag_typedef_t | siptag_min_se
| Tag for Min-SE header object.
tag_typedef_t | siptag_min_se_str
| Tag for string with Min-SE header value.

## Detailed Description

## Macro Definition Documentation

## SIP_MIN_SE_INIT

#define SIP_MIN_SE_INIT | ( |  | ) |

Initializer for structure sip_min_se_t.

A static sip_min_se_t structure for Min-SE header must be initialized with the SIP_MIN_SE_INIT() macro. For instance,

sip_min_se_t sip_min_se = SIP_MIN_SE_INIT;
sip_min_se
#define sip_min_se(sip)
Access a SIP Min-SE header structure sip_min_se_t from sip_t.
Definition sip_protos.h:12269
SIP_MIN_SE_INIT
#define SIP_MIN_SE_INIT()
Initializer for structure sip_min_se_t.
Definition sip_protos.h:12286
sip_min_se_t
struct sip_min_se_s sip_min_se_t
@
Definition sip.h:164

## SIPTAG_MIN_SE

#define SIPTAG_MIN_SE | ( |  | x | ) |

Tag list item for pointer to a Min-SE header structure sip_min_se_t.

The SIPTAG_MIN_SE() macro is used to include a tag item with a pointer to a sip_min_se_t structure in a tag list.

Parameters

  x | pointer to a sip_min_se_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_MIN_SE_REF().

## SIPTAG_MIN_SE_STR

#define SIPTAG_MIN_SE_STR | ( |  | s | ) |

Tag list item for string with Min-SE header value.

The SIPTAG_MIN_SE_STR() macro is used to include a tag item with a string containing value of a sip_min_se_t header in a tag list.

Parameters

  s | pointer to a string containing Min-SE header value, or NULL.

The string in SIPTAG_MIN_SE_STR() can be converted to a sip_min_se_t header structure by giving the string s has second argument to function sip_min_se_make().

The corresponding tag taking reference parameter is SIPTAG_MIN_SE_STR_REF().

## Typedef Documentation

## sip_min_se_t

typedef struct sip_min_se_s sip_min_se_t

@

The Min-SE header is used to indicate the minimum value for the session interval. Its syntax is defined in RFC 4028 as follows:

MMin-SE = "Min-SE" HCOLON delta-seconds *(SEMI generic-param)

The parsed Min-SE header is stored in sip_min_se_t structure.

The structure sip_min_se_t contains representation of the SIP Min-SE header.

The sip_min_se_t is defined as follows:

typedef struct sip_min_se_s
{
sip_common_t min_common[1];
sip_unknown_t *min_next;
unsigned long min_delta; // Delta seconds
sip_params_t *min_params; // List of extension parameters
} sip_min_se_t;
sip_unknown_t
msg_unknown_t sip_unknown_t
@
Definition sip.h:135
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_min_se_s
Structure for Min-SE header.
Definition sip.h:716
sip_min_se_s::min_params
msg_param_t const * min_params
List of extension parameters.
Definition sip.h:720
sip_min_se_s::min_delta
unsigned long min_delta
Delta-seconds.
Definition sip.h:719
sip_min_se_s::min_next
sip_error_t * min_next
Dummy link to next.
Definition sip.h:718
sip_min_se_s::min_common
sip_common_t min_common[1]
Common fragment info.
Definition sip.h:717

## Function Documentation

## sip_is_min_se()

int sip_is_min_se | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_min_se_t.

Check if the header class is an instance of Min-SE header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header min_se
  0 | (false) otherwise

## sip_min_se_copy()

sip_min_se_t * sip_min_se_copy | ( | su_home_t * | home,
|  | sip_min_se_t const * | hdr )

inline

Copy a list of Min-SE header header structures sip_min_se_t.

The function sip_min_se_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  min_se = sip_min_se_copy(home, sip->sip_min_se);
  sip_min_se_copy
  sip_min_se_t * sip_min_se_copy(su_home_t *home, sip_min_se_t const *hdr))
  Copy a list of Min-SE header header structures sip_min_se_t.
  Definition sip_protos.h:12416

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_min_se_dup()

sip_min_se_t * sip_min_se_dup | ( | su_home_t * | home,
|  | sip_min_se_t const * | hdr )

inline

Duplicate a list of Min-SE header header structures sip_min_se_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  min_se = sip_min_se_dup(home, sip->sip_min_se);
  sip_min_se_dup
  sip_min_se_t * sip_min_se_dup(su_home_t *home, sip_min_se_t const *hdr))
  Duplicate a list of Min-SE header header structures sip_min_se_t.
  Definition sip_protos.h:12373

Returns
  A pointer to the newly duplicated sip_min_se_t header structure, or NULL upon an error.

## sip_min_se_format()

sip_min_se_t * sip_min_se_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Min-SE header from formatting result.

Make a new sip_min_se_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_min_se_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_min_se_init()

sip_min_se_t * sip_min_se_init | ( | sip_min_se_t | x[1] | ) |

inline

Initialize a structure sip_min_se_t.

An sip_min_se_t structure for Min-SE header can be initialized with the sip_min_se_init() function/macro. For instance,

sip_min_se_t sip_min_se;
sip_min_se_init(&sip_min_se);
sip_min_se_init
sip_min_se_t * sip_min_se_init(sip_min_se_t x[1])
Initialize a structure sip_min_se_t.
Definition sip_protos.h:12304

## sip_min_se_make()

sip_min_se_t * sip_min_se_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Min-SE header structure sip_min_se_t.

The function sip_min_se_make() makes a new sip_min_se_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_min_se_t header structure, or NULL upon an error.

## Variable Documentation

## sip_min_se_class

msg_hclass_t sip_min_se_class[]

extern

Header class for Min-SE header.

The header class sip_min_se_class defines how a SIP Min-SE header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_min_se_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.